/* -*- Mode: Javascript; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/

const ESURVEY_CONTRACTID = "@uji.es/eSurvey;1";
const ESURVEY_CID        = Components.ID("{20d40da3-66ab-4b29-a3ba-7a8d98dfc2ca}");

const nsISupports      = Components.interfaces.nsISupports;
const nsIFactory       = Components.interfaces.nsIFactory;
const IeSurvey         = Components.interfaces.IeSurvey;
const nsISecCheck      = Components.interfaces.nsISecurityCheckedComponent;
const nsIClassInfo     = Components.interfaces.nsIClassInfo;

const JAVASCRIPT_GLOBAL_CONSTRUCTOR_CATEGORY = "JavaScript global constructor";


var category = JAVASCRIPT_GLOBAL_CONSTRUCTOR_CATEGORY;
var entry    = "eSurveyExtensionLauncher";  





var eSvyState        = 0;  //Variable compartida por todas las instancias
var eSvyParameters   = ''; //Variable compartida por todas las instancias
var eSvyParameterSig = ''; //Variable compartida por todas las instancias




function eSurveyCheckFrames(subwin){
  
  var svys = 0;
  var params = null;
  
  

  try{
  
    //Verificamos si este frame tiene eSurveys
    var page = subwin.document.documentElement.innerHTML;
    
    ////dump("------------Page------------\n"+page+"\n");

    // **** !!!! Podria detectarse si hay ms de 1 match y parar si
    // **** los hay, pero puede provocar conflictos. cogemos el
    // **** primero y punto
    
    params=page.replace(/\n/g,'').match(/<eSurveyParameters>.*?<\/eSurveyParameters>/);
    
    ////dump("------------Params------------\n"+params+"\n");
  
    if(params != null && params != ''){
      svys++;
      ////dump('Hay un eSurvey\n');
    }
    
    ////window.frames[0].frames =0;
    //window.frames[0].document.documentElement.innerHTML
    //subwin.document.documentElement.innerHTML
    //Ahora slo cuenta los frames, poner aqu luego el cdigo para ver si hay un esurvey
    
    
    
    
    ////dump("Es frame hoja? ");
    
    if( subwin.frames == 'undefined' || subwin.frames.length <= 0){  //Es nodo hoja
      
      ////dump("Si. : "+subwin.frames+"\n");
      return svys;    
    }    
    
    ////dump("No.\n");
    
    
    for(var fr=0; fr < subwin.frames.length; fr++){
      
      ////dump("Recorriendo frame "+fr+"\n");
      
      svys += eSurveyCheckFrames(subwin.frames[fr]);
      
    }
  }catch(e){
    //dump("Error. tal vez hay algun tab que no es un DOM (un xml, por ejemplo)\n");
  }
  
  return svys;
}



function eSurveyOpenSurveys(chromewin){

  var svys = 0;

  try{
    
    //Para cada tab abierto
    for(var tab=0; tab<chromewin.gBrowser.browsers.length; tab++){  //Recorre objetos de tipo browser
      
      var currtab = chromewin.gBrowser.getBrowserAtIndex(tab);
      
      ////dump("Viendo tab "+tab+"\n");
      
      //Le pasamos una ref al domwindow
      //svys += eSurveyCheckFrames(currtab.contentDocument.defaultView.window);
      svys += eSurveyCheckFrames(currtab.contentWindow);
      
    }
  }catch(e){
    //dump("Error. recorriendo tabs.\n");
  }
  ////dump("Num de eSurveys abiertos: "+svys+"\n");
  
  ////dump("----------------------------------------\n");
  
  return svys;
}







function eSurveyComp()
{
  var wMed = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                        .getService(Components.interfaces.nsIWindowMediator);

  this.win = wMed.getMostRecentWindow("navigator:browser");

  ////dump('Component: Instanciando eSurveyComp\n');

};



eSurveyComp.prototype.isActive =
function ()
{
  ////dump('isActive: '+eSvyState);

  // 0 -> Barra cerrada 
  // 1 -> Barra abierta, encuesta no enviada
  // 2 -> Barra abierta, encuesta enviada
  // 3 -> Hay varias encuestas abiertas en esta ventana 
  // 4 -> No hay encuestas abiertas en esta ventana 
  
  var numsvys = eSurveyOpenSurveys(this.win);

  if( numsvys==1){
    ////dump('isActive: '+eSvyState+'\n');
    return eSvyState;
  }
  if( numsvys==0){
    ////dump('isActive:  4\n');
    return 4;
  }
  else{
    ////dump('isActive: 3\n');
    return 3;
  }
};


eSurveyComp.prototype.getParams =
function ()
{
  //Devuelve al consumidor los parametros del lanzador, y los borra
  //(porque un consumidor posterior lanzado a mano por el usuario debe
  //encontrar la cadena vacia si no ha sido invocado por un
  //lanzador).
  var aux = eSvyParameters;
  eSvyParameters = '';
  return aux;
}
 

eSurveyComp.prototype.getParamsSig =
function ()
{
  //Devuelve al consumidor los parametros del lanzador, y los borra
  //(porque un consumidor posterior lanzado a mano por el usuario debe
  //encontrar la cadena vacia si no ha sido invocado por un
  //lanzador).
  var aux = eSvyParameterSig;
  eSvyParameterSig = '';
  return aux;
}

 
  
eSurveyComp.prototype.activate =
  function (parameters,signature)
{
  
  if(typeof(parameters) != 'string' || parameters == null){
    var parameters = '';
  }
  
  if(typeof(signature) != 'string' || signature == null){
    var signature = '';
  }
 
  //this.win.alert(this.win.location.href); //Devuelve la URL Chrome

  //this.win.alert(this.win.gBrowser.selectedBrowser.contentDocument.defaultView.window.location.href);  //url del doc web

  if(eSurveyOpenSurveys(this.win)>1){
    //dump('multiples tabs abiertos\n');
  }
  else if(eSvyState==0){
    ////dump('cargando overlay\n');
    eSvyState = 1;

    // *-*-
    //Se escriben ahora en memoria compartida los params recibidos del lanzador (el estado 1 protege de otros lanzadores)
    eSvyParameters   = parameters;
    eSvyParameterSig = signature;

    ////dump("\n-----------Params en el Comp------------\n"+parameters+"\n-----------------------\n");
    ////dump("\n-----------Sig en el Comp------------\n"+signature+"\n-----------------------\n");

    
    this.win.document.loadOverlay('chrome://esurvey/content/esurveyoverlay.xul',null);
  }
  else if(eSvyState<=2){
    //dump('barra ya abierta\n');
  }
  else{
    //dump('error, estado no contemplado\n'); 
  }
};


eSurveyComp.prototype.setState =
function (val)
{
  if(eSvyState==0 && val==2){  //Si la barra esta cerrada, no podemos considerarlo abierto y enviado
      eSvyState = 0;
      ////dump('Ojo, marcando como enviado despues de cerrar (se pedia poner state 2 estando en 0). setting state to 0\n');
  }
  else{
    eSvyState =  val;
    ////dump('setting component state to: '+val+'\n');
  }


};














/*********** INTERNAL ****************/

//New in Gecko 2.0 (Firefox 4.0)
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");


eSurveyComp.prototype.classID = Components.ID(ESURVEY_CID);



// nsISecurityCheckedComponent
eSurveyComp.prototype.canCreateWrapper = function (aIID)
{
  return "AllAccess";
};

eSurveyComp.prototype.canCallMethod = function (aIID, methodName)
{

    if(methodName == 'setState')  //Así evitamos que puedan falsificar el estado desde javascript no privilegiado
       return "NoAccess";
    else
       return "AllAccess";
};

eSurveyComp.prototype.canGetProperty = function (aIID, propertyName)
{
  return "NoAccess";
};

eSurveyComp.prototype.canSetProperty = function (aIID, propertyName)
{
  return "NoAccess";
};



// nsIClassInfo

eSurveyComp.prototype.classDescription = "eSurvey Boostrap";


eSurveyComp.prototype.getInterfaces = function(count) 
{
    var interfaceList = [IeSurvey, nsIClassInfo, nsISecCheck];
    count.value = interfaceList.length;
    return interfaceList;
};

eSurveyComp.prototype.getHelperForLanguage = function(count) 
{
return null;
};

eSurveyComp.prototype.QueryInterface = function (iid) 
{
    if (iid.equals(IeSurvey) ||
        iid.equals(nsIClassInfo) ||
        iid.equals(nsISupports) ||
        iid.equals(nsISecCheck))
        return this;

    Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
    return null;
};



// Module

var esurveycompModule = new Object();

esurveycompModule.firstTime =  true;

esurveycompModule.registerSelf = function (compMgr, fileSpec, location, type)
{
    //obtiene una ref al component manager
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

    //registra la factoria de nuestro comp en el comp manager
    compMgr.registerFactoryLocation(ESURVEY_CID,
                                    "Esurvey secure client",
                                    ESURVEY_CONTRACTID,
                                    fileSpec,
                                    location,
                                    type);

    //obtiene una ref al category manager
    const CATMAN_CONTRACTID = "@mozilla.org/categorymanager;1";
    const nsICategoryManager = Components.interfaces.nsICategoryManager;
    var catman = Components.classes[CATMAN_CONTRACTID].
                            getService(nsICategoryManager);

   
    catman.addCategoryEntry(category,
                            entry,  //Nombre del objeto para instanciarlo en el Js de las webs
                            ESURVEY_CONTRACTID,
                            true, //el cambio en la categoria debe persistir tras cerrar la aplicacion
                            true); //si existia el valor, sobreescribirlo
};


esurveycompModule.unregisterSelf = function (compMgr, fileSpec, location)
{
    compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar)
           .unregisterFactoryLocation(ESURVEY_CID, fileSpec);

     const catman = Components.classes['@mozilla.org/categorymanager;1']
                              .getService(Components.interfaces.nsICategoryManager);
    catman.deleteCategoryEntry(category, entry, true);
};




esurveycompModule.getClassObject = function (compMgr, cid, iid) 
{
    if (!cid.equals(ESURVEY_CID))
        throw Components.results.NS_ERROR_NO_INTERFACE;

    if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    return esurveycompFactory;
};

//Esta funcion es necesario implementarla pero en js es inutil, pq no se
//pueden descargar los modulos en js hasta el final
esurveycompModule.canUnload = function(compMgr)
{
    return false;
};



// Factory
var esurveycompFactory = new Object();

esurveycompFactory.createInstance = function (outer, iid) 
{
    if (outer != null)
        throw Components.results.NS_ERROR_NO_AGGREGATION;

    return (new eSurveyComp()).QueryInterface(iid);
};

// Entry point
function NSGetModule(compMgr, fileSpec) 
{
    return esurveycompModule;
};




//New entry point in Gecko 2.0 (Firefox 4.0)
try{
  const NSGetFactory = XPCOMUtils.generateNSGetFactory([eSurveyComp]);
 }catch(e){
  ////dump("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA\n"+e+"\n");
 }







/*
 //Buscamos la encuesta entre los frames
  
  var surveydoc = document.getElementById('content').contentDocument.documentElement;
  
  var domwin = document.getElementById('content').contentDocument.defaultView.window;

  if(!surveydoc.innerHTML.match(/<eSurveyParameters>.*?<\/eSurveyParameters>/)){
    alert("No hay encuensta en el doc principal");
    
    for(var fr in domwin.frames){
      
      
    }
    
  }
*/

/*
  if(this.win.gBrowser.browsers.length >1)
      eSvyMultitabs = 1;
  else
      eSvyMultitabs = 0;
*/




/*
  for(var index=0; index<numTabs; index++) {
      var currentBrowser = tabbrowser.getBrowserAtIndex(index);
      if (url == currentBrowser.currentURI.spec) {

        // The URL is already opened. Select this tab.
        tabbrowser.selectedTab = tabbrowser.mTabs[index];

        // Focus *this* browser-window
        browserWin.focus();

        found = true;
        break;
      }


*/






    //Devolver cadena con los params del eSurvey

  
  /*
  //Buscamos la encuesta entre los frames
  
  var surveydoc = document.getElementById('content').contentDocument.documentElement;
  
  var domwin = document.getElementById('content').contentDocument.defaultView.window;

  if(!surveydoc.innerHTML.match(/<eSurveyParameters>.*?<\/eSurveyParameters>/)){
    alert("No hay encuensta en el doc principal");
    
    for(var fr in domwin.frames){
      
      
    }
    
  }

*/

/* 
//  var params=surveydoc.innerHTML;

    var params = '<eSurveyParameters> aaa </eSurveyParameters>';
  
  //alert(params);
  params=params.replace(/\n/g,'').match(/<eSurveyParameters>.*?<\/eSurveyParameters>/);
  //alert(params);
*/
